package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.TarjetaCreditoDAO;
import com.rjconsultores.ventaboletos.entidad.TarjetaCredito;
import com.rjconsultores.ventaboletos.service.TarjetaCreditoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("tarjetaCreditoService")
public class TarjetaCreditoServiceImpl implements TarjetaCreditoService {

	@Autowired
	private TarjetaCreditoDAO tarjetaCreditoDAO;

	public List<TarjetaCredito> obtenerTodos() {
		return tarjetaCreditoDAO.obtenerTodos();
	}

	public TarjetaCredito obtenerID(Integer id) {
		return tarjetaCreditoDAO.obtenerID(id);
	}

	@Transactional
	public TarjetaCredito suscribir(TarjetaCredito entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return tarjetaCreditoDAO.suscribir(entidad);
	}

	@Transactional
	public TarjetaCredito actualizacion(TarjetaCredito entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return tarjetaCreditoDAO.actualizacion(entidad);
	}

	@Transactional
	public void borrar(TarjetaCredito entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		tarjetaCreditoDAO.actualizacion(entidad);
	}
}
